-- MySQL dump 10.10
--
-- Host: localhost    Database: aledb
-- ------------------------------------------------------
-- Server version	5.0.18-nt

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `ecspecinstance`
--

DROP TABLE IF EXISTS `ecspecinstance`;
CREATE TABLE `ecspecinstance` (
  `specName` varchar(255) NOT NULL default '',
  `state` int(10) unsigned NOT NULL default '0',
  `stateVersion` int(10) unsigned NOT NULL default '0',
  `previousStartTime` bigint(20) unsigned NOT NULL default '0',
  `previousEndTime` bigint(20) unsigned NOT NULL default '0',
  `startTime` bigint(20) unsigned NOT NULL default '0',
  `specXML` blob,
  `notificationUrls` blob,
  PRIMARY KEY  (`specName`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='ECSpecInstance';

--
-- Table structure for table `logicalreader`
--

DROP TABLE IF EXISTS `logicalreader`;
CREATE TABLE `logicalreader` (
  `logicalreader_id` varchar(30) NOT NULL,
  `suppress` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`logicalreader_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `read_event`
--

DROP TABLE IF EXISTS `read_event`;
CREATE TABLE `read_event` (
  `event_id` bigint(20) NOT NULL auto_increment,
  `reader_id` varchar(30) NOT NULL,
  `timestamp` datetime NOT NULL,
  PRIMARY KEY  (`event_id`),
  KEY `reader_id` (`reader_id`),
  KEY `timestamp` (`timestamp`),
  CONSTRAINT `read_event_ibfk_1` FOREIGN KEY (`reader_id`) REFERENCES `reader` (`reader_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `read_tag`
--

DROP TABLE IF EXISTS `read_tag`;
CREATE TABLE `read_tag` (
  `event_id` bigint(20) NOT NULL,
  `tag_id` varchar(255) NOT NULL,
  PRIMARY KEY  (`event_id`,`tag_id`),
  CONSTRAINT `read_tag_ibfk_1` FOREIGN KEY (`event_id`) REFERENCES `read_event` (`event_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `reader`
--

DROP TABLE IF EXISTS `reader`;
CREATE TABLE `reader` (
  `reader_id` varchar(30) NOT NULL,
  `suppress` tinyint(1) NOT NULL default '0',
  `manufacturer` varchar(30) default NULL,
  `model` varchar(30) default NULL,
  `ipaddress` varchar(30) default NULL,
  PRIMARY KEY  (`reader_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `readermapping`
--

DROP TABLE IF EXISTS `readermapping`;
CREATE TABLE `readermapping` (
  `logicalreader_id` varchar(30) NOT NULL,
  `reader_id` varchar(30) NOT NULL,
  PRIMARY KEY  (`logicalreader_id`,`reader_id`),
  KEY `reader_id` (`reader_id`),
  CONSTRAINT `readermapping_ibfk_1` FOREIGN KEY (`logicalreader_id`) REFERENCES `logicalreader` (`logicalreader_id`) ON DELETE CASCADE,
  CONSTRAINT `readermapping_ibfk_2` FOREIGN KEY (`reader_id`) REFERENCES `reader` (`reader_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

--
-- Table structure for table `specurls`
--

DROP TABLE IF EXISTS `specurls`;
CREATE TABLE `specurls` (
  `specName` varchar(255) NOT NULL default '',
  `notificationUrl` text NOT NULL,
  KEY `FK_specurls_1` (`specName`),
  CONSTRAINT `FK_specurls_1` FOREIGN KEY (`specName`) REFERENCES `ecspecinstance` (`specName`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

